package com.school.project.controller;

import com.school.project.dto.department.DepartmentRegisterDTO;
import com.school.project.service.department.DepartmentServiceImp;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.server.ResponseStatusException;

@RestController
@RequestMapping("/department")
public class DepartmentController {

    @Autowired
    private DepartmentServiceImp departmentServiceImp;

    @PostMapping("/save")
    private ResponseEntity saveDepartment(@RequestBody DepartmentRegisterDTO department){
        try {
            departmentServiceImp.saveDepartment(department);
            return ResponseEntity.ok("Department Saved");
        } catch (Exception e) {
            throw new ResponseStatusException(HttpStatus.BAD_REQUEST,"Data Is Not Correct",e);
        }
    }
}
