package com.school.project.model;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.school.project.model.userRegistration.User;
import com.sun.istack.NotNull;
import lombok.*;
import org.springframework.context.annotation.Lazy;

import javax.persistence.*;

@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
@RequiredArgsConstructor
@Entity
@Table(name = "admin")
public class Admin {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE)
    @Column(name = "admin_id")
    private Long adminId;

    @NotNull
    @Column(name = "admin_name")
    private String name;

    @OneToOne(fetch = FetchType.LAZY)
    @MapsId
    @JoinColumn(name = "admin_id")
    @JsonIgnore
    private User adminAppUser;
}
