package com.school.project.model;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.school.project.model.marks.Assessment;
import com.sun.istack.NotNull;
import lombok.*;

import javax.persistence.*;
import java.util.List;
import java.util.Set;


@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@RequiredArgsConstructor
@Entity
@Table(name = "course")
public class Course {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "course_id")
    private Long courseId;

    @NotNull
    @Column(name = "name", unique = true)
    private String courseName;

    @NotNull
    @Column(name = "course_code",unique = true)
    private String courseCode;

    @ManyToMany(fetch = FetchType.LAZY, mappedBy = "courseLists",cascade = CascadeType.ALL)
    @JsonIgnore
    private Set<Student> studentList;

    @ManyToMany(fetch = FetchType.LAZY, mappedBy = "courseList",cascade = CascadeType.ALL)
    @JsonIgnore
    private Set<Teacher> teacherList;

    @OneToMany(fetch = FetchType.LAZY)
    @JoinTable(name = "courses_assessments",
            joinColumns = {@JoinColumn(name = "course_id",insertable = false,updatable = false)},
            inverseJoinColumns = {@JoinColumn(name = "assessment_id",insertable = false,updatable = false)})
    private List<Assessment> assessments;

}
