package com.school.project.model;

import com.school.project.model.Course;
import com.school.project.model.Department;
import com.school.project.model.userRegistration.User;
import com.sun.istack.NotNull;
import lombok.*;
import org.codehaus.jackson.annotate.JsonIgnore;
import org.springframework.context.annotation.Lazy;

import javax.persistence.*;
import java.util.List;
import java.util.Set;

@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@RequiredArgsConstructor
@Entity
@Table(name = "Teacher")
public class Teacher {

    @Id
    @Column(name = "teacher_id")
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long teacherId;

    @NotNull
    @Column(name = "name")
    private String name;

    @NotNull
    @Column(name = "teacher_num",unique = true)
    private String teacherNumber;

    @NotNull
    @Column(name = "degree")
    private String degree;

    @NotNull
    @JsonIgnore
    @ManyToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "department_id")
    private Department department;

    @JsonIgnore
    @ManyToMany(fetch = FetchType.EAGER, cascade = {CascadeType.ALL})
    @JoinTable(
            name = "teachersCourses",
            joinColumns = {@JoinColumn(name = "teacher_id")},
            inverseJoinColumns = {@JoinColumn(name = "course_id")}
    )
    private Set<Course> courseList;

    @OneToOne(fetch = FetchType.LAZY)
    @MapsId
    @JoinColumn(name = "teacher_id")
    @JsonIgnore
    private User teacherAppUser;


}
