package com.school.project.model.marks;


import com.fasterxml.jackson.annotation.JsonIgnore;
import com.school.project.model.Course;
import com.sun.istack.NotNull;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import java.util.List;

@Getter
@Setter
@Entity
@Table(name = "assessment")
public class Assessment {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE)
    @Column(name = "assessment_id")
    private Long assessmentId;

    @ManyToOne
    @JoinColumn(name = "assessment_type_id")
    @NotNull
    private AssessmentType assessmentType;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinTable(name = "courses_assessments",
    joinColumns = {@JoinColumn(name = "assessment_id")},
    inverseJoinColumns = {@JoinColumn(name = "course_id")})
    @NotNull
    @JsonIgnore
    private Course course;

    @OneToMany(fetch = FetchType.LAZY)
    @JoinTable(name = "assessment_sections",
    joinColumns = {@JoinColumn(name = "assessment_id",insertable = false,updatable = false)},
    inverseJoinColumns = {@JoinColumn(name = "section_id",insertable = false,updatable = false)})
    @JsonIgnore
    private List<Section> section;

}
