package com.school.project.model.marks;

import com.school.project.model.Student;
import com.sun.istack.NotNull;
import lombok.Getter;
import lombok.Setter;
import javax.persistence.*;

@Getter
@Setter
@Entity
@Table(name = "student_marks")
public class StudentMarks {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE)
    @Column(name = "student_marks_id")
    private Long studentMarksId;

    @NotNull
    @Column(name = "obtained_marks")
    private Long obtainedMarks;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinTable(name = "student_obtained_marks",
    joinColumns = {@JoinColumn(name = "student_marks_id")},
    inverseJoinColumns = {@JoinColumn(name = "student_id")})
    @NotNull
    private Student student;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinTable(name = "student_marks_section",
    joinColumns = {@JoinColumn(name = "student_marks_id")},
    inverseJoinColumns = {@JoinColumn(name = "section_id")})
    @NotNull
    private Section section;
}
