package com.school.project.service.admin;

import com.school.project.dto.teacher.TeacherCourseAssignDTO;
import com.school.project.model.Course;
import com.school.project.model.Teacher;
import com.school.project.model.userRegistration.User;
import com.school.project.repository.CourseRepository;
import com.school.project.repository.TeacherRepository;
import com.school.project.repository.userRegistration.UserRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.stereotype.Service;

import javax.transaction.Transactional;
import java.util.Set;

@Service
public class TeacherFunctionsForAdminServiceImpl implements TeacherFunctionsForAdminService {

    @Autowired
    TeacherRepository teacherRepository;

    @Autowired
    UserRepository userRepository;

    @Autowired
    CourseRepository courseRepository;

    @Override
    public Long getUserId(String username) {
        User user = userRepository.findUserByEmail(username).get();
        return user.getUserId();
    }


    @Override
    @Transactional
    @Modifying
    public void assignCourseToTeachers(TeacherCourseAssignDTO assignCourses) {
        Teacher teacher = teacherRepository.findByTeacherNumber(assignCourses.getTeacherNumber());

        Set<Course> teacherCourses = teacher.getCourseList();
        Set<String> newCourses = assignCourses.getCourseList();

        newCourses.forEach(course -> teacherCourses.add(courseRepository.findByCourseName(course)));

        teacher.setCourseList(teacherCourses);
    }
}
