package com.school.project.service.course;

import com.school.project.dto.course.CourseRegisterDTO;
import com.school.project.model.Course;
import com.school.project.repository.CourseRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Service;
import org.springframework.web.server.ResponseStatusException;

@Service
public class CourseServiceImp implements CourseService {

    private static final String courseMessage = "Course Saved";
    private static final String incorrectData = "Data Is Not Correct";
    @Autowired(required = true)
    public CourseRepository courseRepository;

    @Override
    public ResponseStatusException saveCourse(CourseRegisterDTO courseDTO) {

        try {

            Course newCourse = new Course();

            newCourse.setCourseCode(courseDTO.getCourseCode());
            newCourse.setCourseName(courseDTO.getCourseName());

            courseRepository.save(newCourse);

            return new ResponseStatusException(HttpStatus.OK,courseMessage);

        } catch (Exception e) {

            return new ResponseStatusException(HttpStatus.BAD_REQUEST,incorrectData,e);
        }
    }
}
