package com.school.project.service.student;

import com.school.project.dto.student.StudentCourseRegistrationDTO;
import com.school.project.model.Course;
import com.school.project.model.Student;
import com.school.project.repository.CourseRepository;
import com.school.project.repository.StudentRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.stereotype.Service;

import javax.transaction.Transactional;
import java.util.Set;

@Service
public class CourseRegistrationServiceImpl implements CourseRegistrationService {

    @Autowired
    private StudentRepository studentRepository;

    @Autowired
    private CourseRepository courseRepository;


    @Override
    @Transactional
    @Modifying
    public void courseRegistration(Long id, Set<StudentCourseRegistrationDTO> courses) {
        Student student = studentRepository.findByStudentId(id);

        Set<Course> studentCourses = student.getCourseLists();

        courses.forEach(course -> studentCourses.add(courseRepository.findByCourseName(course.getCourseName())));

        student.setCourseLists(studentCourses);


    }
}
