package com.school.project.service.student;

import com.school.project.dto.student.StudentCoursesDTO;
import com.school.project.dto.student.StudentViewDataDTO;
import com.school.project.mapper.StudentCoursesMapper;
import com.school.project.mapper.StudentViewDataMapper;
import com.school.project.model.userRegistration.User;
import com.school.project.repository.StudentRepository;
import com.school.project.repository.userRegistration.UserRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;


@Service
public class StudentServiceImpl implements StudentService {

    @Autowired
    private StudentRepository studentRepository;

    @Autowired
    private UserRepository userRepository;

    @Autowired
    private StudentViewDataMapper studentViewDataMapper;

    @Autowired
    private StudentCoursesMapper studentCoursesMapper;

    @Override
    public Long getUserId(String username) {
        User user = userRepository.findUserByEmail(username).get();
        return user.getUserId();
    }

    @Override
    public StudentViewDataDTO viewData(String username) {

        User user = userRepository.findUserByEmail(username).get();
        StudentViewDataDTO student = studentViewDataMapper.modelToDto(studentRepository.findByStudentId(user.getUserId()));

        return student;
    }


    @Override
    public StudentCoursesDTO viewCourses(Long id) {

        return studentCoursesMapper.modelToDto(studentRepository.findByStudentId(id));
    }
}


