package com.school.project.service.userRegistration;

import com.school.project.model.userRegistration.Role;
import com.school.project.model.userRegistration.User;
import com.school.project.repository.userRegistration.UserRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.core.authority.SimpleGrantedAuthority;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Service;

import java.util.HashSet;
import java.util.Optional;
import java.util.Set;

@Service
public class UserServiceImpl implements UserDetailsService {

    @Autowired
    private UserRepository userRepository;

    @Override
    public UserDetails loadUserByUsername(String email) throws UsernameNotFoundException {

        Optional<User> userEmail = userRepository.findUserByEmail(email);

        org.springframework.security.core.userdetails.User springUser = null;

        if (userEmail.isEmpty()) {
            throw new UsernameNotFoundException("User Not Found");
        } else {

            User userByEmail = userEmail.get();
            Role userByRoles = userByEmail.getRole();
            String userSpecifiedRoles = userByRoles.getRole();

            Set<GrantedAuthority> userAuthorities = new HashSet<>();

            userAuthorities.add(new SimpleGrantedAuthority(userSpecifiedRoles));

            springUser = new org.springframework.security.core.userdetails.User(
                    email,
                    userByEmail.getPassword(),
                    userAuthorities);
        }

        return springUser;
    }
}
