package com.school.project.service.userRegistration.admin;

import com.school.project.dto.userRegistration.AdminRegistrationDTO;
import com.school.project.dto.userRegistration.UserRegistrationDTO;
import com.school.project.model.Admin;
import com.school.project.model.userRegistration.Role;
import com.school.project.model.userRegistration.User;
import com.school.project.repository.userRegistration.AdminRegRepository;
import com.school.project.repository.userRegistration.RoleRepository;
import com.school.project.repository.userRegistration.UserRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.crypto.password.PasswordEncoder;
import org.springframework.stereotype.Service;

@Service
public class AdminRegistrationServiceImpl implements AdminRegistrationService {

    @Autowired
    private AdminRegRepository adminRegRepository;

    @Autowired
    private UserRepository userRepository;

    @Autowired
    private RoleRepository roleRepository;

    @Autowired
    private PasswordEncoder passwordEncoder;

    public UserRegistrationDTO registerAdmin(AdminRegistrationDTO admin) {

        User newUser = new User();

        newUser.setEmail(admin.getEmail());
        newUser.setPassword(passwordEncoder.encode(admin.getPassword()));
        newUser.setRole(roleRepository.findByRole(Role.ROLES.ADMIN.name()));

        newUser = userRepository.save(newUser);

        Admin newAdmin = new Admin();
        newAdmin.setName(admin.getName());
        newAdmin.setAdminAppUser(newUser);

        adminRegRepository.save(newAdmin);

        return new UserRegistrationDTO(newUser.getUserId(), newUser.getEmail());

    }

}
